<?php

/* * ********************************************************************
 * ProxmoxAddon product developed. (Oct 1, 2018)
 * *
 *
 *  CREATED BY MODULESGARDEN       ->       http://modulesgarden.com
 *  CONTACT                        ->       contact@modulesgarden.com
 *
 *
 * This software is furnished under a license and may be used and copied
 * only  in  accordance  with  the  terms  of such  license and with the
 * inclusion of the above copyright notice.  This software  or any other
 * copies thereof may not be provided or otherwise made available to any
 * other person.  No title to and  ownership of the  software is  hereby
 * transferred.
 *
 *
 * ******************************************************************** */

namespace ModulesGarden\Servers\ProxmoxCloudVps\App\UI\Graph\Pages;

use ModulesGarden\Servers\ProxmoxCloudVps\Core\UI\Widget\Graphs\Models\DataSet;
use function ModulesGarden\Servers\ProxmoxCloudVps\Core\Helper\sl;

class NetworkSmallGraph extends BaseSmallGraph
{
    protected $id = 'networkSmallGraph';
    protected $name = 'networkSmallGraph';

    public function initContent()
    {
        $this->updateChartScale('yAxes', [
            [
                'scaleLabel' => [
                    'display'     => $this->displayScaleLabel,
                    'labelString' => sl('lang')->tr('Network')
                ],
                'ticks'      => [
                    'callback' => 'mgBytesToSize',
                    'beginAtZero' => true,
                    'fontSize' => 10
                ],
            ]]);
        $this->updateChartOption('tooltips', [
            'callbacks' => [
                'label' => 'mgTooltipCallbackForNet'
            ]
        ]);

        $this->updateChartScale('xAxes', [
            [
                'display'   => false
            ]]);
        $this->configChartsSettings->timeframe = 'day';
        $this->timeframe = 'day';
    }

    public function prepareAjaxData()
    {
        session_write_close();
        $labels     = [];
        $dataSets   = [
            'netin'     => [],
            'netout'    => [],
        ];
        foreach ($this->rrdDataQuery() as $rrd)
        {
            $labels[]               = $rrd->date;
            $dataSets['netin'][]    = isset($rrd->netin) ? (float)$rrd->netin : 0;
            $dataSets['netout'][]   = isset($rrd->netout) ? (float)$rrd->netout : 0;
        }


        //Labels
        $this->setLabels($labels);
        //net in
        $lang    = sl('lang');
        $dataSet = new DataSet();
        $dataSet->setTitle($lang->tr('Net In'))
            ->setData($dataSets['netin'])
            ->setConfigurationDataSet([
                "backgroundColor" => 'rgba(174, 198, 57, 0.79)',
                "borderColor"     => 'rgba(174, 198, 57, 1)',
            ]);
        $this->addDataSet($dataSet);
        //net out
        $dataSet = new DataSet();
        $dataSet->setTitle($lang->tr('Net Out'))
            ->setData($dataSets['netout'])
            ->setConfigurationDataSet([
                "backgroundColor" => 'rgba(39, 133, 134, 0.91)',
                "borderColor"     => 'rgba(39, 133, 134, 1)',
            ]);
        $this->addDataSet($dataSet);
    }


}
